/*
hold_stop

hiroi01iniLibraryg킹Ă炢܂B
肪Ƃ܂B
*/

#include <pspkernel.h>
#include <pspctrl.h>
#include <pspimpose_driver.h>
#include <pspsysevent.h>

#include <systemctrl.h>

#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#include "libinip.h"
#include "thread.h"
/*-----------------------------------------------------------------*/

PSP_MODULE_INFO("hold_stop", 0x1000, 1, 0);

#define INI_PATH "/hold_stop.ini"
#define	PSP_SYSEVENT_SUSPEND_QUERY	0x100
#define PSP_SYSEVENT_RESUME_COMPLETELY 0x400000
#define MAKE_CALL(a, f)	_sw(0x0C000000 | (((u32)(f) >> 2) & 0x03FFFFFF), a);

ILP_Key key[1];
u32 ResumeButton;
bool suspend = false;

/*------------------------------------------------------------------*/
int main_thread(SceSize args, void *argp);
int module_start(SceSize args, void *argp);
int module_stop(SceSize args, void *argp);

int sceKernelGetModel();

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
//  Callback_Suspend
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
int Callback_Suspend(int ev_id, char *ev_name, void *param, int *result)
{
	// Ԃl 0 ł͂Ȃ -1 ԂƁAX[v𖳌ł
	
	// X[v
	if( ev_id == PSP_SYSEVENT_SUSPEND_QUERY)
	{
		if(suspend)resumeThreads();
	}
	else if(ev_id == PSP_SYSEVENT_RESUME_COMPLETELY)
	{
		if(suspend)suspendThreads();
	}
	
	return 0;
}

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
//  libctrlWaitButtonUp		Thanks SnyFbSx	// from cmlibCtrl
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

int libctrlWaitButtonUp(u32 buttons)
{
	SceCtrlData pad;
	
	sceCtrlPeekBufferPositive( &pad, 1 );
	while( (pad.Buttons & buttons) != 0 ){
		sceCtrlPeekBufferPositive( &pad, 1 );
		sceKernelDelayThread( 50000 );
	}
	
	return 0;
}

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
//  libctrlWaitButtonDown		// from cmlibCtrl
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

int libctrlWaitButtonDown(u32 buttons)
{
	SceCtrlData pad;

	sceCtrlPeekBufferPositive( &pad, 1 );
	while( (pad.Buttons & buttons) != buttons ){
		sceCtrlPeekBufferPositive( &pad, 1 );
		sceKernelDelayThread( 50000 );
	}

	return 0;
}

void (*sub_0009C_Real)(int arg1);

void sub_0009C_Patched(int arg1)
{
	if(suspend)resumeThreads();
	return sub_0009C_Real(arg1);
}

void ClearCaches(void)
{
	sceKernelDcacheWritebackAll();
	sceKernelIcacheClearAll();
}


#define GO_MODEL 4

int ExitGamePatch()
{
	u32 text_addr, text_end;
	int model = sceKernelGetModel();
	SceModule2 *mod = sceKernelFindModuleByName("sceImpose_Driver");
	if(mod == NULL)return -1;
	
	text_addr = mod->text_addr;
	text_end = mod->text_addr + mod->text_size;
	
	sub_0009C_Real = (void *)(text_addr + 0x0000009C);
	
	for(; text_addr < text_end; text_addr += 4)
	{
		if(model == GO_MODEL)
		{
			if(_lw(text_addr + 4) == 0xAD2A00A4 && _lw(text_addr - 4) == 0x016C5025)
			{
				break;
			}
		} else {
			if(_lw(text_addr + 4) == 0xAD0900A4 && _lw(text_addr - 4) == 0x014B4825)
			{
				break;
			}
		}
	}
	if(text_addr < text_end)
	{
		MAKE_CALL(text_addr, sub_0009C_Patched);
		ClearCaches();
		return 0;
	}
	return -1;
}


/*------------------------------------------------------------------*/
void roadIni(char *path)
{
	char iniPath[256];
	char *temp;

	strcpy(iniPath, path);
	temp = strrchr(iniPath, '/');
	if( temp != NULL ) *temp = '\0';
	strcat(iniPath, INI_PATH);
	
	// init@C̓ǂݍ݂̉
	ILPInitKey(key);
	
	ILPRegisterButton(key,	"ResumeButton",	&ResumeButton,	0, NULL);
	
	if(ILPReadFromFile(key, iniPath) == -1){
		// init@C֏
		ILPWriteToFile(key, iniPath, "\r\n");//ǂݍ߂Ȃ玩ō쐬
	}
}

/*------------------------------------------------------------------*/

int main_thread(SceSize args, void *argp)
{
	SceCtrlData pad;
	PspSysEventHandler events;
	//Xbh~܂PSPTXyh
	//t[Y̌ɂȂ̂ŉ邽߂̏
	events.size			= sizeof(PspSysEventHandler);
	events.name			= "MSE_Suspend";
	events.type_mask	= 0x00FFFF00;
	events.handler		= Callback_Suspend;
	
	sceKernelRegisterSysEventHandler(&events);
	
	while( sceKernelFindModuleByName("sceKernelLibrary") == NULL )
	{
		sceKernelDelayThread(1000);
	}
	Get_FirstThreads();
	roadIni(argp);
	ExitGamePatch();
	
	while (1)
	{
		sceKernelDelayThread(50000);
		sceCtrlPeekBufferPositive( &pad, 1 );
		if(pad.Buttons & PSP_CTRL_HOLD)
		{
			suspendThreads();
			suspend = Get_ThreadModeStatus();
			libctrlWaitButtonUp(PSP_CTRL_HOLD);
			libctrlWaitButtonDown(ResumeButton);
			resumeThreads();
			suspend = Get_ThreadModeStatus();
		}
	}
	
	return 0;
}

/*------------------------------------------------------------------*/

int module_start(SceSize args, void *argp)
{

	int thid = sceKernelCreateThread("hold_stop", main_thread, 32, 0x2000, 0, NULL);
	if(thid >= 0)sceKernelStartThread(thid, args, argp);

	return 0;
}


int module_stop(SceSize args, void *argp)
{
	return 0;
}

